#!/bin/bash

EXPECTED_ARGS=3

if [ $# -ne $EXPECTED_ARGS ]
then
    echo "Usage: `basename $0` <scadaA> <scadaB> <output csv>"
    exit 1
fi

SCADAA=$1
SCADAB=$2
NORMAL=$3

# tmux new-session -d -s "${line[0]} $COMMAND" "ssh -n ${line[0]} '$COMMAND'"

#COMMAND="./spire-src-1.3/prime/bin/attack_client -f $SCADAA.csv -i 7 -s $SCADAA -l $(hostname -i)"
tmux new-session -d -s "$SCADAA" "ssh -n scada$SCADAA 'cd spire-src-1.3/prime/bin && ./attack_client -i 7 -s $SCADAA -l $(hostname -i) -n 2500 -f $NORMAL 2>&1 | tee latencies/normal.txt'"
sleep 3
tmux new-session -d -s "$SCADAB" "ssh -n scada$SCADAB 'pkill prime && cd faulty-spire/prime/bin && ./prime -i $SCADAB && ./attack_client -i 8 -s $SCADAB -l $(hostname -i) -n 2500 2>&1 | tee latencies/attack.txt'"
echo Attack begins at: $(($(date +%s)))
