#!/bin/bash

EXPECTED_ARGS=5

if [ $# -ne $EXPECTED_ARGS ]
then
    echo "Usage: `basename $0` <scadaA> <scadaB> <emulation number> <normal output csv> <attack output csv>"
    exit 1
fi

SCADAA=$1
SCADAB=$2
EMULATIONS=$3
NORMAL=$4
ATTACK=$5

# tmux new-session -d -s "${line[0]} $COMMAND" "ssh -n ${line[0]} '$COMMAND'"

#COMMAND="./spire-src-1.3/prime/bin/attack_client -f $SCADAA.csv -i 7 -s $SCADAA -l $(hostname -i)"
tmux new-session -d -s "$SCADAA" "ssh -n scada$SCADAA 'cd spire-src-1.3/prime/bin && ./attack_client -i 7 -s $SCADAA -l $(hostname -i) -f $NORMAL.csv -n 10000 -c 1 2>&1 | tee latencies/normal_$NORMAL.txt'"
sleep 5
tmux new-session -d -s "$SCADAB" "ssh -n scada$SCADAB 'cd spire-src-1.3/prime/bin && ./attack_client -i 8 -s $SCADAB -l $(hostname -i) -f $ATTACK.csv -n 500 -c $EMULATIONS 2>&1 | tee latencies/attack_$ATTACK.txt'"

